diff --git a/web/pgadmin/tools/datagrid/__init__.py b/web/pgadmin/tools/datagrid/__init__.py
index 1bd841f..f7b836a 100644
--- a/web/pgadmin/tools/datagrid/__init__.py
+++ b/web/pgadmin/tools/datagrid/__init__.py
@@ -18,22 +18,23 @@ from flask import Response, url_for, session, request, make_response
 from werkzeug.useragents import UserAgent
 from flask import current_app as app, render_template
 from flask_babelex import gettext
-from flask_security import login_required
+from flask_security import login_required, current_user
 from pgadmin.tools.sqleditor.command import ObjectRegistry, SQLFilter
+from pgadmin.tools.sqleditor import check_transaction_status
 from pgadmin.utils import PgAdminModule
 from pgadmin.utils.ajax import make_json_response, bad_request, \
-    internal_server_error
+    internal_server_error, unauthorized
 
 from config import PG_DEFAULT_DRIVER
-from pgadmin.model import Server
+from pgadmin.model import Server, User
 from pgadmin.utils.driver import get_driver
 from pgadmin.utils.exception import ConnectionLost, SSHTunnelConnectionLost
 from pgadmin.utils.preferences import Preferences
 from pgadmin.settings import get_setting
 from pgadmin.browser.utils import underscore_unescape
 from pgadmin.utils.exception import ObjectGone
-from pgadmin.utils.constants import MIMETYPE_APP_JS
 from pgadmin.tools.sqleditor.utils.macros import get_user_macros
+from pgadmin.utils.constants import MIMETYPE_APP_JS, UNAUTH_REQ
 
 MODULE_NAME = 'datagrid'
 
@@ -74,7 +75,8 @@ class DataGridModule(PgAdminModule):
             'datagrid.filter_validate',
             'datagrid.filter',
             'datagrid.panel',
-            'datagrid.close'
+            'datagrid.close',
+            'datagrid.update_query_tool_connection'
         ]
 
     def on_logout(self, user):
@@ -324,10 +326,48 @@ def initialize_query_tool(trans_id, sgid, sid, did=None):
             req_args['recreate'] == '1'):
         connect = False
 
+    is_error, errmsg, conn_id, version = _init_query_tool(trans_id, connect,
+                                                          sgid, sid, did)
+    if is_error:
+        return errmsg
+
+    return make_json_response(
+        data={
+            'connId': str(conn_id),
+            'serverVersion': version,
+        }
+    )
+
+
+def _connect(conn, **kwargs):
+    """
+    Connect the database.
+    :param conn: Connection instance.
+    :param kwargs: user, role and password data from user.
+    :return:
+    """
+    user = None
+    role = None
+    password = None
+    is_ask_password = False
+    if 'user' in kwargs and 'role' in kwargs:
+        user = kwargs['user']
+        role = kwargs['role'] if kwargs['role'] else None
+        password = kwargs['password'] if kwargs['password'] else None
+        is_ask_password = True
+    if user:
+        status, msg = conn.connect(user=user, role=role,
+                                   password=password)
+    else:
+        status, msg = conn.connect()
+
+    return status, msg, is_ask_password, user, role, password
+
+
+def _init_query_tool(trans_id, connect, sgid, sid, did, **kwargs):
     # Create asynchronous connection using random connection id.
     conn_id = str(random.randint(1, 9999999))
 
-    # Use Maintenance database OID
     manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(sid)
 
     if did is None:
@@ -338,24 +378,41 @@ def initialize_query_tool(trans_id, sgid, sid, did=None):
         )
     except Exception as e:
         app.logger.error(e)
-        return internal_server_error(errormsg=str(e))
+        return True, internal_server_error(errormsg=str(e)), '', ''
 
     try:
         conn = manager.connection(did=did, conn_id=conn_id,
                                   auto_reconnect=False,
                                   use_binary_placeholder=True,
                                   array_to_string=True)
+
         if connect:
-            status, msg = conn.connect()
+            status, msg, is_ask_password, user, role, password = _connect(
+                conn, **kwargs)
             if not status:
                 app.logger.error(msg)
-                return internal_server_error(errormsg=str(msg))
+                if is_ask_password:
+                    server = Server.query.filter_by(id=sid).first()
+                    return True, make_json_response(
+                        success=0,
+                        status=428,
+                        result=render_template(
+                            'servers/password.html',
+                            server_label=server.name,
+                            username=user,
+                            errmsg=msg,
+                            _=gettext,
+                        )
+                    ), '', ''
+                else:
+                    return True, internal_server_error(
+                        errormsg=str(msg)), '', ''
     except (ConnectionLost, SSHTunnelConnectionLost) as e:
         app.logger.error(e)
         raise
     except Exception as e:
         app.logger.error(e)
-        return internal_server_error(errormsg=str(e))
+        return True, internal_server_error(errormsg=str(e)), '', ''
 
     if 'gridData' not in session:
         sql_grid_data = dict()
@@ -377,10 +434,77 @@ def initialize_query_tool(trans_id, sgid, sid, did=None):
     # Store the grid dictionary into the session variable
     session['gridData'] = sql_grid_data
 
+    return False, '', conn_id, manager.version
+
+
+@blueprint.route(
+    '/initialize/query_tool/update_connection/<int:trans_id>/'
+    '<int:sgid>/<int:sid>/<int:did>',
+    methods=["POST"], endpoint='update_query_tool_connection'
+)
+def update_query_tool_connection(trans_id, sgid, sid, did):
+    # Remove transaction Id.
+    with query_tool_close_session_lock:
+        data = json.loads(request.data, encoding='utf-8')
+
+        if 'gridData' not in session:
+            return make_json_response(data={'status': True})
+
+        grid_data = session['gridData']
+
+        # Return from the function if transaction id not found
+        if str(trans_id) not in grid_data:
+            return make_json_response(data={'status': True})
+
+        connect = True
+
+        req_args = request.args
+        if ('recreate' in req_args and
+                req_args['recreate'] == '1'):
+            connect = False
+
+        new_trans_id = str(random.randint(1, 9999999))
+        kwargs = {
+            'user': data['user'],
+            'role': data['role'],
+            'password': data['password'] if 'password' in data else None
+        }
+
+        is_error, errmsg, conn_id, version = _init_query_tool(
+            new_trans_id, connect, sgid, sid, did, **kwargs)
+
+        if is_error:
+            return errmsg
+        else:
+            try:
+                # Check the transaction and connection status
+                status, error_msg, conn, trans_obj, session_obj = \
+                    check_transaction_status(trans_id)
+
+                status, error_msg, new_conn, new_trans_obj, new_session_obj = \
+                    check_transaction_status(new_trans_id)
+
+                new_session_obj['primary_keys'] = session_obj[
+                    'primary_keys'] if 'primary_keys' in session_obj else None
+                new_session_obj['columns_info'] = session_obj[
+                    'columns_info'] if 'columns_info' in session_obj else None
+                new_session_obj['client_primary_key'] = session_obj[
+                    'client_primary_key'] if 'client_primary_key'\
+                                             in session_obj else None
+
+                close_query_tool_session(trans_id)
+                # Remove the information of unique transaction id from the
+                # session variable.
+                grid_data.pop(str(trans_id), None)
+                session['gridData'] = grid_data
+            except Exception as e:
+                app.logger.error(e)
+
     return make_json_response(
         data={
             'connId': str(conn_id),
-            'serverVersion': manager.version,
+            'serverVersion': version,
+            'tran_id': new_trans_id
         }
     )
 
diff --git a/web/pgadmin/tools/datagrid/tests/test_data_grid_init_query_tool.py b/web/pgadmin/tools/datagrid/tests/test_data_grid_init_query_tool.py
new file mode 100644
index 0000000..6ecf5de
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_data_grid_init_query_tool.py
@@ -0,0 +1,72 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from . import utils as data_grid_utils
+
+
+class DatagridInitQueryToolTestCase(BaseTestGenerator):
+    """
+    This will init query-tool connection.
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_init_query_tool',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+
+        self.trans_id = str(random.randint(1, 9999999))
+
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+
+    def init_query_tool(self):
+        response = self.tester.post(
+            self.url + str(self.trans_id) + '/' + str(self.sgid) + '/' + str(
+                self.sid) + '/' + str(self.did),
+            content_type='html/json'
+        )
+        return response
+
+    def runTest(self):
+        """ This function will init query tool connection."""
+
+        if self.is_positive_test:
+            response = self.init_query_tool()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+
+            self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
diff --git a/web/pgadmin/tools/datagrid/tests/test_data_grid_panel.py b/web/pgadmin/tools/datagrid/tests/test_data_grid_panel.py
new file mode 100644
index 0000000..ae8ec10
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_data_grid_panel.py
@@ -0,0 +1,93 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from . import utils as data_grid_utils
+
+
+class DatagridPanelTestCase(BaseTestGenerator):
+    """
+    This will data grid panel.
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_panel',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+
+        self.trans_id = str(random.randint(1, 9999999))
+        qt_init = data_grid_utils._init_query_tool(self, self.trans_id,
+                                                   self.sgid, self.sid,
+                                                   self.did)
+
+        if not qt_init['success']:
+            raise Exception("Could not initialize querty tool.")
+
+    def panel(self):
+        query_param = \
+            '?is_query_tool={0}&sgid={1}&sid={2}&server_type={3}' \
+            '&did={4}&title={5}'.format(True, self.sgid, self.sid,
+                                        self.server_information['type'],
+                                        self.did, 'Query panel')
+
+        response = self.tester.post(
+            self.url + str(self.trans_id) + query_param,
+            data=json.dumps(self.test_data),
+            content_type='html/json'
+        )
+        return response
+
+    def runTest(self):
+        """ This function will update query tool connection."""
+
+        if self.is_positive_test:
+            response = self.panel()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            with patch(self.mock_data["function_name"],
+                       return_value=eval(self.mock_data["return_value"])):
+                response = self.panel()
+                actual_response_code = response.status_code
+                expected_response_code = self.expected_data['status_code']
+
+        self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
diff --git a/web/pgadmin/tools/datagrid/tests/test_data_grid_query_tool_close.py b/web/pgadmin/tools/datagrid/tests/test_data_grid_query_tool_close.py
new file mode 100644
index 0000000..822c2e1
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_data_grid_query_tool_close.py
@@ -0,0 +1,77 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from . import utils as data_grid_utils
+
+
+class DatagridQueryToolCloseTestCase(BaseTestGenerator):
+    """
+    This will close query-tool connection.
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_query_tool_close',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+
+        self.trans_id = str(random.randint(1, 9999999))
+        qt_init = data_grid_utils._init_query_tool(self, self.trans_id,
+                                                   self.sgid, self.sid,
+                                                   self.did)
+
+        if not qt_init['success']:
+            raise Exception("Could not initialize querty tool.")
+
+    def close_connection(self):
+        response = self.tester.delete(
+            self.url + str(self.trans_id),
+            content_type='html/json'
+        )
+        return response
+
+    def runTest(self):
+        """ This function will update query tool connection."""
+
+        if self.is_positive_test:
+            response = self.close_connection()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+
+            self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
diff --git a/web/pgadmin/tools/datagrid/tests/test_data_grid_update_connection.py b/web/pgadmin/tools/datagrid/tests/test_data_grid_update_connection.py
new file mode 100644
index 0000000..5d2b14a
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_data_grid_update_connection.py
@@ -0,0 +1,120 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from pgadmin.browser.server_groups.servers.roles.tests import \
+    utils as roles_utils
+from . import utils as data_grid_utils
+
+
+class DatagridUpdateConnectionTestCase(BaseTestGenerator):
+    """
+    This will update query-tool connection.
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_update_connection',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+
+        self.trans_id = str(random.randint(1, 9999999))
+        self.roles = None
+
+        if self.is_create_role:
+            data = roles_utils.get_role_data(self.server['db_password'])
+            self.role_name = data['rolname']
+            self.role_password = data['rolpassword']
+            roles_utils.create_role_with_password(
+                self.server, self.role_name, self.role_password)
+
+        if not self.is_positive_test or self.is_create_role:
+            qt_init = data_grid_utils._init_query_tool(self, self.trans_id,
+                                                       self.sgid, self.sid,
+                                                       self.did)
+
+            if not qt_init['success']:
+                raise Exception("Could not initialize querty tool.")
+
+        self.test_data = {
+            "database": self.did,
+            "server": self.sid,
+        }
+
+        if self.server_information['type'] == 'ppas':
+            self.test_data['password'] = 'enterprisedb'
+            self.test_data['user'] = 'enterprisedb'
+        else:
+            self.test_data['password'] = 'postgres'
+            self.test_data['user'] = 'postgres'
+
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+
+    def update_connection(self, user_data=None):
+        if user_data:
+            response = self.tester.post(
+                self.url + str(self.trans_id) + '/' + str(self.sgid) +
+                '/' + str(self.sid) + '/' + str(self.did),
+                data=json.dumps(user_data),
+                content_type='html/json'
+            )
+        else:
+            response = self.tester.post(
+                self.url + str(self.trans_id) + '/' + str(self.sgid) + '/' +
+                str(self.sid) + '/' + str(self.did),
+                data=json.dumps(self.test_data),
+                content_type='html/json'
+            )
+        return response
+
+    def runTest(self):
+        """ This function will update query tool connection."""
+
+        if self.is_positive_test:
+            user_data = dict()
+            if self.is_create_role:
+                user_data['user'] = self.role_name
+                user_data['password'] = self.role_password
+                user_data['role'] = None
+            response = self.update_connection(user_data=user_data)
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            response = self.update_connection()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+
+        self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
diff --git a/web/pgadmin/tools/datagrid/tests/test_data_grid_validate_filter.py b/web/pgadmin/tools/datagrid/tests/test_data_grid_validate_filter.py
new file mode 100644
index 0000000..0aba5d8
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_data_grid_validate_filter.py
@@ -0,0 +1,91 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from . import utils as data_grid_utils
+
+
+class DatagridValidateFilterTestCase(BaseTestGenerator):
+    """
+    This will validate filter connection.
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_validate_filter',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+        self.schema_id = parent_node_dict['schema'][-1]["schema_id"]
+        self.schema_name = parent_node_dict['schema'][-1]["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add a table.")
+        self.table_name = "table_for_wizard%s" % (str(uuid.uuid4())[1:8])
+        self.table_id = tables_utils.create_table(self.server, self.db_name,
+                                                  self.schema_name,
+                                                  self.table_name)
+
+    def validate_filter(self):
+        response = self.tester.post(
+            self.url + str(self.sid) + '/' + str(self.did) + '/' +
+            str(self.table_id),
+            data=json.dumps(self.test_data),
+            content_type='html/json'
+        )
+        return response
+
+    def runTest(self):
+        """ This function will update query tool connection."""
+
+        if self.is_positive_test:
+            response = self.validate_filter()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            with patch(self.mock_data["function_name"],
+                       return_value=eval(self.mock_data["return_value"])):
+                response = self.validate_filter()
+                actual_response_code = response.status_code
+                expected_response_code = self.expected_data['status_code']
+
+        self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
diff --git a/web/pgadmin/tools/datagrid/tests/test_initialize_data_grid.py b/web/pgadmin/tools/datagrid/tests/test_initialize_data_grid.py
new file mode 100644
index 0000000..130a1d6
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/test_initialize_data_grid.py
@@ -0,0 +1,108 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+import json
+import uuid
+import random
+
+from unittest.mock import patch
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
+    utils as schema_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
+    import utils as tables_utils
+from . import utils as data_grid_utils
+
+
+class DatagridInitializeTestCase(BaseTestGenerator):
+    """
+    This will Initialize datagrid
+    """
+
+    scenarios = utils.generate_scenarios(
+        'data_grid_initialize',
+        data_grid_utils.test_cases
+    )
+
+    def setUp(self):
+        self.database_info = parent_node_dict["database"][-1]
+        self.db_name = self.database_info["db_name"]
+        self.did = self.database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+        db_con = database_utils.connect_database(self, utils.SERVER_GROUP,
+                                                 self.sid, self.did)
+        if not db_con['data']["connected"]:
+            raise Exception("Could not connect to database to add a table.")
+
+        self.schema_id = parent_node_dict['schema'][-1]["schema_id"]
+        self.schema_name = parent_node_dict['schema'][-1]["schema_name"]
+        schema_response = schema_utils.verify_schemas(self.server,
+                                                      self.db_name,
+                                                      self.schema_name)
+        if not schema_response:
+            raise Exception("Could not find the schema to add a table.")
+        self.table_name = "table_for_wizard%s" % (str(uuid.uuid4())[1:8])
+        self.table_id = tables_utils.create_table(self.server, self.db_name,
+                                                  self.schema_name,
+                                                  self.table_name)
+        self.trans_id = str(random.randint(1, 9999999))
+        qt_init = data_grid_utils._init_query_tool(self, self.trans_id,
+                                                   self.sgid, self.sid,
+                                                   self.did)
+
+        if not qt_init['success']:
+            raise Exception("Could not initialize query tool.")
+
+    def initialize_datagrid(self):
+        if self.test_data:
+            response = self.tester.post(
+                self.url + str(self.trans_id) + '/4/table/' +
+                str(self.sgid) + '/' + str(self.sid) + '/' +
+                str(self.did) + '/' + str(self.table_id),
+                data=json.dumps(self.test_data),
+                content_type='html/json'
+            )
+        else:
+            response = self.tester.post(
+                self.url + str(self.trans_id) + '/4/table/' +
+                str(self.sgid) + '/' + str(self.sid) + '/' +
+                str(self.did) + '/' + str(self.table_id),
+                content_type='html/json'
+            )
+        return response
+
+    def runTest(self):
+        """ This function will update query tool connection."""
+
+        if self.is_positive_test:
+            response = self.initialize_datagrid()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            with patch(self.mock_data["function_name"],
+                       return_value=eval(self.mock_data["return_value"])):
+                response = self.initialize_datagrid()
+                actual_response_code = response.status_code
+                expected_response_code = self.expected_data['status_code']
+
+        self.assertEqual(actual_response_code, expected_response_code)
+
+    def tearDown(self):
+        """This function disconnect database."""
+        database_utils.disconnect_database(self, self.sid,
+                                           self.did)
